//+------------------------------------------------------------------+
//|                                                  KirillMACD1.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+


//    
extern double Lots = 0.01;

//    
extern double TrailingStop = 350;

//    
extern double StopLoss = 350;

//    
extern int KolOrd = 10;

//    ?
//extern double MACDOpenLevel=3;

//    ?
//extern double MACDCloseLevel=2;

//    ?
//extern double MATrendPeriod=26;

//+----------------------------------------------------1--------------+
//|                                                                   |
//+-------------------------------------------------------------------+

int Count; //  

double OsmaOdin, OsmaDva, OsmaTri;

int start() //   
  {

   Count++;
   int cnt, ticket, total;
   // cnt -  
   //ticket -    
   //total -     ;
  
  //    
 
 
 //-----------------------------------------------------2---------------------------------------
  
 
 //     ()  100 
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
     

 //-------------------------------------------------------3--------------------------------------
 
  //  ,       
  // sMA   ,          
  //      ( ).      ,
  //   ,      ( ).
  
 //      
 
  OsmaOdin = 10000000*iOsMA(NULL,0,12,26,9,PRICE_OPEN,2);
  Alert("  ",Count,"  OsmaOdin  = ", OsmaOdin);

  OsmaDva = 10000000*iOsMA(NULL,0,12,26,9,PRICE_OPEN,1);
    Alert("  ",Count,"  OsmaDva  = ", OsmaDva);

  OsmaTri = 10000000*iOsMA(NULL,0,12,26,9,PRICE_OPEN,0);
    Alert("  ",Count,"  OsmaTri  = ", OsmaTri);

  //-------------------------------------------------------4--------------------------------------
  
   //     total      . 
   total=OrdersTotal();  
 
  //-------------------------------------------------------5--------------------------------------
 
   if(total<1) 
     {
      //     -------------5.1---------------------------------------
     
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("   .  Free Margin = ", AccountFreeMargin());
         return(0);  
        }
  //-------------------------------------------------------5.1--------------------------------------
       //     ,      --------
  //-------------------------------------------------------5.2--------------------------------------   
      if(OsmaOdin>OsmaDva && OsmaDva<OsmaTri)
        {
         Alert("   ");
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,0,"macd sample",16384,0,Green);
         Alert("   ticket = ",ticket);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Alert("     .   = ",GetLastError()); 
         return(0); 
        }
  //-------------------------------------------------------5.2---------------------------------------    
       //     ,      --------
  //-------------------------------------------------------5.3---------------------------------------    
      if(OsmaOdin<OsmaDva && OsmaDva>OsmaTri)
        {
         Alert("   ");
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,0,"macd sample",16384,0,Red);
         Alert("   ticket = ",ticket);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Alert("     .   = ",GetLastError()); 
         return(0); 
        }
  //-------------------------------------------------------5.3---------------------------------------    
      return(0);
     }
   //-------------------------------------------------------5-----------------------------------------------------------------------------    
 
  
  //-----------------------------------------------------------------------------------------------------------------
  //-------   ,     ------------------------------------------
  //-----------------------------------------------------------------------------------------------------------------
  
  //-------------------------------------------------------6-------------------------------------------------------------------------------
   for(cnt=0;cnt<total;cnt++)  //    ,    
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES); //     ,     
   //-------------------------------------------------------6.1--------------------------------------
    
      if(OrderType()<=OP_SELL &&   // check for opened position                ,   
         OrderSymbol()==Symbol())  // check for symbol                        ,  ...
        {
         //      
    //-------------------------------------------------------6.1.1-------------------
            
         if(OrderType()==OP_BUY)   // long position is opened                ,..   , ...
           {
           
            //      
      //----------------------------------------------------6.1.1.1-------
         
            if(OsmaOdin<OsmaDva && OsmaDva>OsmaTri)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
      //----------------------------------------------------6.1.1.1-------
           
            //      
      //----------------------------------------------------6.1.1.2-------
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                    // OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
      //----------------------------------------------------6.1.1.2-------
         
            //      
      //----------------------------------------------------6.1.1.3-------
   
      //----------------------------------------------------6.1.1.3-------
           }
           
    //-------------------------------------------------------6.1.1-------------------
         
         
         
         //      
    //-------------------------------------------------------6.1.2-------------------
         else // go to short position
           {
      
            //      
      //----------------------------------------------------6.1.2.1-------
            if(OsmaOdin>OsmaDva && OsmaDva<OsmaTri)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
      //----------------------------------------------------6.1.2.1-------
   
            //      
      //----------------------------------------------------6.1.2.2-------
             if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     //OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
      //----------------------------------------------------6.1.2.2-------

            //      
      //----------------------------------------------------6.1.2.3-------
   
      //----------------------------------------------------6.1.2.3-------
           }
 
    //-------------------------------------------------------6.1.2-------------------
       }
   //-------------------------------------------------------6.1--------------------------------------
     }
   return(0);
   //-------------------------------------------------------6-------------------------------------------------------------------------------
 }
// the end.